

;**************************************************************************
;--------------------------------------------------------------------------
;                        AntiAlarm
;--------------------------------------------------------------------------
; (c) 01.02.2003 Miroslav Gola e-mail: emgo@iol.cz
;==========================================================================
; ANTIEASY.ASM je soucasti publikace v casop. Prakticka elektronika 3/2003
; *************  Zakladni varianta ovladaciho programu  *******************
; Urceno jen pro individualni stavbu zarizeni AnitiAlarm. Jiny zpusob uziti
; bez povoleni autora neni dovoleno!
; Aktualni informace: http://www.emgola.cz/
;==========================================================================
;
; Definice vstupu AntiAlarm
; P3.2  IN2
; P3.3  IN1
; P3.5  TEST BUTTON
;
; Definice vystupu AntiAlarm
; P3.0  LED INDIKACE
; P3.4  PLAY BUTTON
; P3.7  REC SYNTEZA  "AtmelKec Peter Misenko, e-mail: mouse@host.sk"
; P1.0  REC SUM1
; P1.1  REC SUM2
; P1.2  RELE SEPNUTI

;**************************************************************************

; Reference 4MHz Xtal >> 
; 

	IN2 	bit  P3.2	; bit je v 0, kdyz je pozad. na start od vst.IN2	
	IN1 	bit  P3.3	; bit je v 0, kdyz je pozad. na start od vst.IN1	
	TEST 	bit  P3.5	; pomocny bitik - proti GND spusti akci
	LED 	bit  P3.0	; bit je v 0, kdyz je zahaj. akce, D sviti
	PLAY 	bit  P3.4	; bit je v 0, kdyz je pozad. na start prehrav. z.	
	KEC  	bit  P3.7	; bitik, ktery predava signal z AtmelKec
	RCS1 	bit  P1.0	; bitik, ktery predava signal ze sum. gener. 1
	RCS2 	bit  P1.1	; bitik, ktery predava signal ze sum. gener. 2
	RELE 	bit  P1.2	; bit je v 1, kdyz ma rele sepnout
	PORT3	set  00h	; uschova stav P3

;**************************************************************************
		org	0000h
		jmp	start

		org	0003h
		jmp	int_in2		;podprogram pro osetreni vstupu IN2=INT0=P3.2
		
		;org	000bh
		;jmp	int_CT0		;preteceni casovace CT0
		
		org	0013h
		jmp	int_in1		;podprogram pro osetreni vstupu IN1=INT1=P3.3

		org	0030h

START:      	call	ini
		call	blik		;dioda LED D2 zablika
		;call	akce		;provede se obsluha periferii
		mov	tmod,#01000001b	;16bit casovac interval cca 200ms
   		mov	ie,#10000111b	;povol ext. prer. 0 a 1+CT0
USNI:	 	mov	tl0,#00h
   		mov	th0,#00h
   		setb	tr0		;zacni odpocitavat	
		mov	pcon,#01h	;IDLE MOD
		jmp	usni	
			
;**************************************************************************
INI:		clr	ea		;zakaz jakakoliv jina preruseni
		setb	led		;zhasni LED D2 .. P3.0 na "H"
		clr	play		;play vypni .. P3.4 na "L"
		clr	rele		;rele vypni .. P1.2 na "L"
		mov r7,#50d 		;=500ms nastavi pred call wr7x10ms
		call	wr7x10ms	;zpozdeni 500 ms
		setb	ea
		ret
;**************************************************************************
;procedura vykona "hlavni akci", tzn sepne a vypne zaznamnik a rele
;--------------------------------------------------------------------------

INT_IN2:   	clr	ea		;zakaz jakakoliv jina preruseni
		mov	r7,#50d		;nastaveni cekaci doby tlacitka
		mov	a, p3		;stav P3 do akumulatoru
		orl 	A,#11010011b	;vymaskuj nezapojene vstupy
 		cjne A,#11011111b,DALE	;je zmacknuto tlacitko TEST?
		call testik		;kdyz ano, proved proceduru TESTIK
DALE:		call	wr7x10ms	;cekej 10x r7 ms
		call in1akce		;vykonej akci 1
		setb	ea
		reti                    ;vypadni 

;**************************************************************************
;procedura pro predcasne a vnucene ukonceni "hlavni akce"
;--------------------------------------------------------------------------

INT_IN1:	clr	ea		;zakaz jakakoliv jina preruseni
		mov	r7,#50d         ;nastaveni cekaci doby tlacitka
		setb play		;zmackni tlacitko play (P3.4 na "H")
		call	wr7x10ms	;cekej 10x r7 ms
		clr  play		;uvolni tlacitko play (P3.4 na "L")
		mov  r7,#50d		;nastaveni cekaci doby 
		call wr7x10ms		;zpozedeni 500ms
		clr rele		;vypne 
		call blik
		setb	ea
		reti
;**************************************************************************
;Rozsviti LED D2 .. 2x blikne
;--------------------------------------------------------------------------

BLIK:      	clr	led		;2x blikni LED
  		mov 	r7,#10d 	;=10x10=100ms 
	 	call	wr7x10ms
	 	setb	led
	 	call	wr7x10ms
	 	clr	led
	 	call	wr7x10ms
 		setb	led
        	ret
;**************************************************************************
;		mov r7,#50d =500ms .. nastavi cekaci dobu pred volanim wr7x10ms
;podprogram pro jalovou cekaci smycku na R7x10ms. V r7 je pocet 10ms interv.
;hodnoty delay1 a 2 jsou pro krystal 4MHz (1MC=3us) dany:
;--------------------------------------------------------------------------

		delay1    set	0dh
		delay2    set	7fh
		
wr7x10ms:	clr	ea
  loadr6:	mov	r6,#delay1
  loadr5:	mov	r5,#delay2
  zustan:   	djnz   	r5,zustan
  		cpl KEC				; piska tonem cca 1kHz
		djnz	r6,loadr5
		djnz	r7,loadr6
		setb	ea		;zakaz jakakoliv jina preruseni
		ret
;**************************************************************************
;procedura pro nastaveni nizkofrekvencniho vystupu
;--------------------------------------------------------------------------
TESTIK:		call blik		;zabika dioda D2
 		mov  r7,#50d		;nastaveni cekaci doby wr7x10ms
 		mov R3,#00
RV:  		mov R4,#00
		cpl kec			;zapiska tonem cca 1 kHz na P3.7
      		djnz R4,$
      		djnz R3,RV
 		call wr7x10ms		;zpozdeni 10ms*50=500ms
		ret
;**************************************************************************

IN1AKCE:	call blik
		setb play		;play zapni .. P3.4 na "H"
		mov  r7,#50d		;nastaveni doby zm. tl. PLAY
		call wr7x10ms		;zpozdeni 10ms*50=0,5 s
		clr  play		;tlacitko 1 na H .. P3.4 na "L"
		mov  r7,#0FEh		;nastaveni 2. cekaci doby 
		mov  r2,#0Ah		;zpozdeni 2,54s*10=25s
					;nyni dojde k ukonceni prehravani zpravy
delay:		call wr7x10ms		;zpozdeni 10ms*254=2,54s
		djnz r2,delay
		call relekuan		;zapne a vypne rele KUAN
		call blik
		ret			;navrat
;**************************************************************************
RELEKUAN:	setb rele		;sepne rele KUAN
		mov  r7,#0FEh		;nastaveni 1. cekaci doby 
		mov  r2,#0Ah		;zpozdeni 2,54s*5=12s
dele:		call wr7x10ms		;zpozdeni 10ms*254=2,54s
		djnz r2,dele
		clr  rele		;vypne rele KUAN
		ret		
;**************************************************************************

		END				
